﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.TreeView;
using Telerik.Windows.Controls.DragDrop;
using Telerik.Windows.Controls;
using Telerik.Windows;

namespace TreeViewDNDWithCopy
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            radTreeViewLeft.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(DropQuery), true);
            radTreeViewRight.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(DropQuery), true);


            radTreeViewLeft.ExpandAll();
            radTreeViewRight.ExpandAll();
        }


        public RadTreeViewItem CopyItem(EditableHeaderedItemsControl item)
        {
            RadTreeViewItem newItem = new RadTreeViewItem();
            newItem.Header = item.Header;
            return newItem;
        }

        private void radTreeViewPreviewDragEnded(object sender, RadTreeViewDragEndedEventArgs e)
        {
            RadTreeView targetTree = e.TargetDropItem.ParentOfType<RadTreeView>();
            RadTreeView sourceTree = (e.DraggedItems[0] as EditableHeaderedItemsControl).ParentOfType<RadTreeView>();
            if (targetTree == sender && sourceTree != targetTree)
            {
                foreach (object item in e.DraggedItems)
                {
                    RadTreeViewItem clonedItem = CopyItem(item as EditableHeaderedItemsControl);
                    e.TargetDropItem.Items.Add(clonedItem);
                }
            }
            e.Handled = true;
        }

        private void DropQuery(object sender, DragDropQueryEventArgs e)
        {
            RadTreeView sourceTree = (e.Options.Source as EditableHeaderedItemsControl).ParentOfType<RadTreeView>();
            RadTreeView targetTree = new RadTreeView();
            FrameworkElement destination = e.Options.Destination;
            if (destination is RadTreeViewItem)
            {
                targetTree = (destination as RadTreeViewItem).ParentTreeView;

            }
            else if (destination is RadTreeView)
            {
                targetTree = destination as RadTreeView;

            }
            if (targetTree == sourceTree)
            {
                e.QueryResult = false;
                e.Handled = true;
            }
            else
            {
                e.QueryResult = true;
                e.Handled = true;
            }
        }


    }
}
